#!/usr/bin/python
__author__ = 'Piotr Matuszczyk <piotr.matuszczyk@sap.com>'

import yaml, dns.resolver, string, random, dns.exception
from dns.rdatatype import (A)


def parse_vars_file(vars_file_location):
  with open(vars_file_location, 'r') as varsfile:
    cfg = yaml.load(varsfile)
  return cfg

def resolveARecord(name, nameservers):
  resolver = dns.resolver.Resolver()
  resolver.nameservers = nameservers
  a = resolver.query(name, 'A')
  return a.rrset[-1]

def generateRandomPasswd(l):
  p = string.letters + string.digits
  return ''.join((random.choice(p)) for i in range(l))