#!/usr/bin/python
__author__ = 'Piotr Matuszczyk <piotr.matuszczyk@sap.com>'

class IterResource(type):
  def __iter__(self, cls):
    return iter(self, cls._registry)

class Vraresource(object):
  __metaclass__ = IterResource
  _registry = []
  def __init__(self):
    self._registry.append(self)
    self.name = None
    self.id = None
    self.type = None
    self.description = None
    self.status = None
    self.catalogid = None
    self.requestid = None
    self.owner = None
    self.createdate =  None
    self.updatedate = None
    self.childids = []
    self.actionids = []
    self.network = {}
#    self.network = []
    self.memory = None
    self.cpu = None
    self.reservationname = None
    self.extrefid = None
    self.hostgroup = None
    self.tierpart = {}
  
  def unmarshalling(self, j, mngdomain, nameservers):
    self.id = j['id']
    self.name = j['name']
    if j['resourceTypeRef']['label'] == 'Virtual Machine':
      self.type = 'vm'
    elif j['resourceTypeRef']['label'] == 'Multi-Machine Service':
      self.type = 'multitier'
    self.description = j['description']
    self.status = j['status']
    self.catalogid = j['catalogItem']['id']
    self.requestid = j['requestId']
    for a in j['owners']:
      self.owner = a['value']
    self.createdate = j['dateCreated']
    self.updatedate = j['lastUpdated']
    if self.type == 'multitier':
      for b in j['childResources']:
        self.childids.append(b['id'])
    for c in j['operations']:
      self.actionids.append({c['name'].replace(" ","").lower(): c['id']})
    for d in j['resourceData']['entries']:
      if d['key'] == 'NETWORK_LIST':
        for m in d['value']['items']:
          for n in m['values']['entries']:
            if n['key'] == 'NETWORK_ADDRESS':
              self.network['ipaddress'] = n['value']['value']
#              self.network.append(n['value']['value'])
            if n['key'] == 'NETWORK_MAC_ADDRESS':
              self.network['macaddress'] = n['value']['value']
#              self.network.append(n['value']['value'])
            if n['key'] == 'NETWORK_NAME':
              self.network['name'] = n['value']['value']
#              self.network.append(n['value']['value'])
      elif d['key'] == 'MachineMemory':
        self.memory = d['value']['value']
      elif d['key'] == 'MachineCPU':
        self.cpu = d['value']['value']
      elif (d['key'] == 'MachineReservationName' and self.type == 'vm'):
        self.reservationname = d['value']['value']
      elif (d['key'] == 'EXTERNAL_REFERENCE_ID' and self.type == 'vm'):
        self.extrefid = d['value']['value']
      elif d['key'] == 'IS_COMPONENT_MACHINE':
        self.tierpart['tierpart'] = d['value']['value']
    if self.type == 'vm':
      self.hostgroup = j['name'].split('-')[-2]
    if self.tierpart['tierpart']:
      self.tierpart['parentID'] = j['parentResourceRef']['id']
      self.network['external_ipaddress'] = str(resolveARecord(self.name+mngdomain, nameservers))
      
      
from vrealize_6_ansible.helpers import resolveARecord
